# -*- coding: utf-8 -*-
"""
Created on Sun Apr 23 20:44:07 2023

@author: Pablo
"""

import matplotlib.pyplot as plt
import numpy as np
from scipy.signal import chirp, find_peaks, peak_widths


def findmaxrange(array,minim,maxim):
    #print(array.shape[0])
    newarr = array[np.where((minim< array[:,0]) & (maxim>array[:,0]))]     
    #print (np.argwhere(array == np.max(newarr)))    
    return  np.argwhere(array[:,1] == np.max(newarr[:,1])) 
   
def integraterange(array,minim,maxim):
    newarr = array[np.where((minim< array[:,0]) & (maxim>array[:,0]))]     
    #print (np.trapz(newarr[::-1,1],newarr[::-1,0]))
    return  np.trapz(newarr[::-1,1],newarr[::-1,0]) 

def FWHM(array,minim,maxim):
    newarr = array[np.where((minim< array[:,0]) & (maxim>array[:,0]))]
    X= newarr[:,0]
    Y = newarr[:,1]
    d = Y - (max(Y) / 2)
    indexes = np.where(d > 0)[0]
    return abs(X[indexes[-1]] - X[indexes[0]])
plt.rcParams["figure.dpi"]=150
#plt.rcParams["figure.facecolor"]="black"
plt.rcParams["figure.figsize"]=(8, 6)
h = 4.1357E-15 #eVs
c = 299792458E9 #nm/s
# load data
spectra0h = np.loadtxt('../profile/WS2-WSE2 0h.txt')
spectra3h = np.loadtxt('../profile/WS2-WSE2 3h.txt')
spectra4h = np.loadtxt('../profile/WS2-WSE2 4h.txt')
spectra6h = np.loadtxt('../profile/WS2-WSE2 6h.txt')
spectra9h = np.loadtxt('../profile/WS2-WSE2 9h.txt')

spectra0h[:,0] = h*c/spectra0h[:,0] 
spectra3h[:,1] = spectra3h[:,1] - np.min(spectra3h[:,1])
spectra4h[:,1] = (spectra4h[:,1] - np.min(spectra4h[:,1]))
spectra6h[:,1] = (spectra6h[:,1] - np.min(spectra6h[:,1]))
spectra9h[:,1] = (spectra9h[:,1] - np.min(spectra9h[:,1]))

plt.plot(h*c/spectra0h[:,0],spectra0h[:,1], label = "Sin recocido (60uW)")
plt.plot(h*c/spectra3h[:,0],spectra3h[:,1], label = "3h recocido (60uW)")
plt.plot(h*c/spectra4h[:,0],spectra4h[:,1], label = "4h recocido (450uW)" )
plt.plot(h*c/spectra6h[:,0],spectra6h[:,1], label = "6h recocido (400uW)")
plt.plot(h*c/spectra9h[:,0],spectra9h[:,1], label = "9h recocido (400uW)")
plt.xlim(1.2,2.6)
plt.legend(loc = 'upper right')
plt.xlabel("Energía (eV)")
plt.ticklabel_format(axis = 'y',style = "sci",scilimits = (0,0))
plt.ylabel("Intensidad PL (cuentas")
plt.title("Respuesta PL de WS2-WSe2 respecto al tiempo de recocido")
plt.show()


#normal
norm0h = (spectra0h[:,1]-np.min(spectra0h[:,1])) /(np.max(spectra0h[:,1])-np.min(spectra0h[:,1]))
norm3h= spectra3h[:,1]/np.max(spectra3h[:,1])
norm4h= spectra4h[:,1]/np.max(spectra4h[:,1])
norm6h= spectra6h[:,1]/np.max(spectra6h[:,1])
norm9h= spectra9h[:,1]/np.max(spectra9h[:,1])

plt.plot(h*c/spectra0h[:,0],norm0h[:], label = "Sin recocido")
plt.plot(h*c/spectra3h[:,0],norm3h[:], label = "3h recocido")
plt.plot(h*c/spectra4h[:,0],norm4h[:], label = "4h recocido" )
plt.plot(h*c/spectra6h[:,0],norm6h[:], label = "6h recocido")
plt.plot(h*c/spectra9h[:,0],norm9h[:], label = "9h recocido")
plt.xlim(1.2,2.4)

plt.xlabel("Energía (eV)")
plt.ylabel("Intensidad PL (normalizada por espectro)")
plt.title("Respuesta PL de WS2-WSe2 respecto al tiempo de recocido (Normalizado)")
plt.legend()
plt.show()

plt.figure()
x = h*c/spectra9h[:,0]
plt.plot(x,norm9h[:], label = "9h anneal")
plt.xlim(1.2,2.2)
plt.xlabel("Energía (eV)")
plt.ylabel("Intensidad (u.a.)")
plt.title("Respuesta PL a 9h de recocido" )
plt.show()

#find max 1.65 peak
max0h1Se = h*c/spectra0h[findmaxrange(spectra0h,700,800)][0,0][0]
max3h = h*c/spectra3h[findmaxrange(spectra3h,700,800)][0,0][0]
max4h = h*c/spectra4h[findmaxrange(spectra4h,700,800)][0,0][0]
max6h = h*c/spectra6h[findmaxrange(spectra6h,700,850)][0,0][0]
max9h = h*c/spectra6h[findmaxrange(spectra6h,700,850)][0,0][0]
max0h1S = h*c/spectra0h[findmaxrange(spectra0h,550,650)][0,0][0]

#integrate 1.65peak
area0h1Se = integraterange(spectra0h,700,800)
area3h = integraterange(spectra3h,650,800)
area4h = integraterange(spectra4h,700,850)
area6h = integraterange(spectra6h,700,880)
area9h = integraterange(spectra9h,700,880)

width0h = FWHM(spectra0h,700,800)
width3h = FWHM(spectra3h,650,800)
width4h = FWHM(spectra4h,700,850)
width6h = FWHM(spectra6h,700,850)
width9h = FWHM(spectra9h,700,850)

#find max 1.4 peak
maxi3h = h*c/spectra3h[findmaxrange(spectra3h,800,1000)][0,0][0]
maxi4h = h*c/spectra4h[findmaxrange(spectra4h,900,1000)][0,0][0]
maxi6h = h*c/spectra6h[findmaxrange(spectra6h,900,1000)][0,0][0]
maxi9h = h*c/spectra6h[findmaxrange(spectra9h,900,1000)][0,0][0]

#integrate 1.3 peak
areai3h = integraterange(spectra3h,800,950)
areai4h = integraterange(spectra4h,850,1000)
areai6h = integraterange(spectra6h,880,1000)
areai9h = integraterange(spectra9h,880,1000)

widthi3h = FWHM(spectra3h,850,950)
widthi4h = FWHM(spectra4h,850,1000)
widthi6h = FWHM(spectra6h,850,1000)
widthi9h = FWHM(spectra9h,850,1000)

#Proportion IX vs X0 peak
prop3h = areai3h/area3h
prop4h = areai4h/area4h
prop6h = areai6h/area6h
prop9h = areai6h/area9h

widthprop3h = widthi3h/width3h
widthprop4h = widthi4h/width4h
widthprop6h = widthi6h/width6h
widthprop9h = widthi9h/width9h

area1 = np.array([areai3h,areai4h,areai6h,areai9h])
width1 = np.array([width3h,width4h,width6h,width9h])
forlin1 = np.array ([[0,max0h1Se],[3,max3h],[4,max4h],[6,max6h],[9,max9h]])
forlini1 = np.array ([[3,maxi3h],[4,maxi4h],[6,maxi6h],[9,maxi9h]])
area1prop = np.array([[3,prop3h],[4,prop4h],[6,prop6h],[9,prop9h]])
width1prop = np.array([[3,widthprop3h],[4,widthprop4h],[6,widthprop6h],[9,widthprop9h]])


areatot0h1 = integraterange(spectra0h, 500, 1000)
areatot3h1 = integraterange(spectra3h, 500, 1000)
areatot4h1 = integraterange(spectra4h, 500, 1000)
areatot6h1 = integraterange(spectra6h, 500, 1000)
areatot9h1 = integraterange(spectra9h, 500, 1000)

areatot1 = np.array([areatot0h1,areatot3h1,areatot4h1,areatot6h1,areatot9h1])



"""CHAngeeeeeeeeeeeeee"""
# load data
spectra0h = np.loadtxt('../profile/WS2-WSE2 0h_muestra2.txt')
spectra3h = np.loadtxt('../profile/WS2-WSE2 3h_muestra2.txt')
spectra4h = np.loadtxt('../profile/WS2-WSE2 4h_muestra2.txt')
spectra6h = np.loadtxt('../profile/WS2-WSE2 6h_muestra2.txt')
spectra9h = np.loadtxt('../profile/WS2-WSE2 9h_muestra2.txt')

spectra0h[:,0] = h*c/spectra0h[:,0] 
spectra3h[:,1] = spectra3h[:,1] - np.min(spectra3h[:,1])
spectra4h[:,1] = (spectra4h[:,1] - np.min(spectra4h[:,1]))
spectra6h[:,1] = (spectra6h[:,1] - np.min(spectra6h[:,1]))
spectra9h[:,1] = (spectra9h[:,1] - np.min(spectra9h[:,1]))

plt.figure()
plt.plot(h*c/spectra0h[:,0],spectra0h[:,1], label = "Sin recocido (60uW)")
plt.plot(h*c/spectra3h[:,0],spectra3h[:,1], label = "3h recocido (60uW)")
plt.plot(h*c/spectra4h[:,0],spectra4h[:,1], label = "4h recocido (450uW)" )
plt.plot(h*c/spectra6h[:,0],spectra6h[:,1], label = "6h recocido (400uW)")
plt.plot(h*c/spectra9h[:,0],spectra9h[:,1], label = "9h recocido (400uW)")
plt.xlim(1.2,2.6)
plt.legend(loc = 'upper right')
plt.xlabel("Energía (eV)")
plt.ticklabel_format(axis = 'y',style = "sci",scilimits = (0,0))
plt.ylabel("Intensidad PL (cuentas")
plt.title("Respuesta PL de WS2-WSe2 respecto al tiempo de recocido")
plt.show()#normal
norm0h = (spectra0h[:,1]-np.min(spectra0h[:,1])) /(np.max(spectra0h[:,1])-np.min(spectra0h[:,1]))
norm3h= spectra3h[:,1]/np.max(spectra3h[:,1])
norm4h= spectra4h[:,1]/np.max(spectra4h[:,1])
norm6h= spectra6h[:,1]/np.max(spectra6h[:,1])
norm9h= spectra9h[:,1]/np.max(spectra9h[:,1])

plt.plot(h*c/spectra0h[:,0],norm0h[:], label = "Sin recocido")
plt.plot(h*c/spectra3h[:,0],norm3h[:], label = "3h recocido")
plt.plot(h*c/spectra4h[:,0],norm4h[:], label = "4h recocido" )
plt.plot(h*c/spectra6h[:,0],norm6h[:], label = "6h recocido")
plt.plot(h*c/spectra9h[:,0],norm9h[:], label = "9h recocido")
plt.xlim(1.2,2.4)

plt.xlabel("Energía (eV)")
plt.ylabel("Intensidad PL (normalizada por espectro)")
plt.title("Respuesta PL de WS2-WSe2 respecto al tiempo de recocido (Normalizado)")
plt.legend()
plt.show()
#find max 1.65 peak
max0h2Se = h*c/spectra0h[findmaxrange(spectra0h,700,800)][0,0][0]
max3h = h*c/spectra3h[findmaxrange(spectra3h,700,800)][0,0][0]
max4h = h*c/spectra4h[findmaxrange(spectra4h,760,850)][0,0][0]
max6h = h*c/spectra6h[findmaxrange(spectra6h,780,820)][0,0][0]
max9h = h*c/spectra6h[findmaxrange(spectra9h,780,820)][0,0][0]
max0h2S = h*c/spectra0h[findmaxrange(spectra0h,550,650)][0,0][0]

#integrate 1.65peak
area0h2Se = integraterange(spectra0h,700,800)
area3h = integraterange(spectra3h,650,800)
area4h = integraterange(spectra4h,700,850)
area6h = integraterange(spectra6h,750,850)
area9h = integraterange(spectra9h,750,850)

width0h = FWHM(spectra0h,700,800)
width3h = FWHM(spectra3h,650,800)
width4h = FWHM(spectra4h,700,850)
width6h = FWHM(spectra6h,700,880)
width9h = FWHM(spectra9h,700,880)

#find max 1.4 peak
maxi3h = h*c/spectra3h[findmaxrange(spectra3h,800,1000)][0,0][0]
maxi4h = h*c/spectra4h[findmaxrange(spectra4h,900,1000)][0,0][0]
maxi6h = h*c/spectra6h[findmaxrange(spectra6h,900,1000)][0,0][0]
maxi9h = h*c/spectra9h[findmaxrange(spectra9h,900,1000)][0,0][0]

#integrate 1.3 peak
areai3h = integraterange(spectra3h,850,1000)
areai4h = integraterange(spectra4h,850,1000)
areai6h = integraterange(spectra6h,880,980)
areai9h = integraterange(spectra9h,880,980)

widthi3h = FWHM(spectra3h,850,950)
widthi4h = FWHM(spectra4h,850,1000)
widthi6h = FWHM(spectra6h,880,1000)
widthi9h = FWHM(spectra9h,880,1000)

#Proportion IX vs X0 peak
prop3h = areai3h/area3h
prop4h = areai4h/area4h
prop6h = areai6h/area6h
prop9h = areai9h/area9h

widthprop3h = widthi3h/width3h
widthprop4h = widthi4h/width4h
widthprop6h = widthi6h/width6h
widthprop9h = widthi9h/width9h

area2 = np.array([areai3h,areai4h,areai6h,areai9h])
width2 = np.array([width3h,width4h,width6h,width9h])
forlin2 = np.array ([[0,max0h2Se],[3,max3h],[4,max4h],[6,max6h],[9,max9h]])
forlini2 = np.array ([[3,maxi3h],[4,maxi4h],[6,maxi6h],[9,maxi9h]])
area2prop = np.array([[3,prop3h],[4,prop4h],[6,prop6h],[9,prop9h]])
width2prop = np.array([[3,widthprop3h],[4,widthprop4h],[6,widthprop6h],[9,widthprop9h]])

areatot0h2 = integraterange(spectra0h, 500, 1000)
areatot3h2 = integraterange(spectra3h, 500, 1000)
areatot4h2 = integraterange(spectra4h, 500, 1000)
areatot6h2 = integraterange(spectra6h, 500, 1000)
areatot9h2 = integraterange(spectra9h, 500, 1000)

areatot2 = np.array([areatot0h2,areatot3h2,areatot4h2,areatot6h2,areatot9h2])

"""CHAngeeeeeeeeeeeeee"""
# load data
spectra0h = np.loadtxt('../profile/WS2-WSE2 0h_muestra3.txt')
spectra3h = np.loadtxt('../profile/WS2-WSE2 3h_muestra3.txt')
spectra4h = np.loadtxt('../profile/WS2-WSE2 4h_muestra3.txt')
spectra6h = np.loadtxt('../profile/WS2-WSE2 6h_muestra3.txt')
spectra9h = np.loadtxt('../profile/WS2-WSE2 9h_muestra3.txt')

spectra0h[:,0] = h*c/spectra0h[:,0] 
spectra3h[:,1] = spectra3h[:,1] - np.min(spectra3h[:,1])
spectra4h[:,1] = (spectra4h[:,1] - np.min(spectra4h[:,1]))
spectra6h[:,1] = (spectra6h[:,1] - np.min(spectra6h[:,1]))
spectra9h[:,1] = (spectra9h[:,1] - np.min(spectra9h[:,1]))

plt.figure()
plt.plot(h*c/spectra0h[:,0],spectra0h[:,1], label = "Sin recocido (60uW)")
plt.plot(h*c/spectra3h[:,0],spectra3h[:,1], label = "3h recocido (60uW)")
plt.plot(h*c/spectra4h[:,0],spectra4h[:,1], label = "4h recocido (450uW)" )
plt.plot(h*c/spectra6h[:,0],spectra6h[:,1], label = "6h recocido (400uW)")
plt.plot(h*c/spectra9h[:,0],spectra9h[:,1], label = "9h recocido (400uW)")
plt.xlim(1.2,2.6)
plt.legend(loc = 'upper right')
plt.xlabel("Energía (eV)")
plt.ticklabel_format(axis = 'y',style = "sci",scilimits = (0,0))
plt.ylabel("Intensidad PL (cuentas")
plt.title("Respuesta PL de WS2-WSe2 respecto al tiempo de recocido")
plt.show()
#normal
norm0h = (spectra0h[:,1]-np.min(spectra0h[:,1])) /(np.max(spectra0h[:,1])-np.min(spectra0h[:,1]))
norm3h= spectra3h[:,1]/np.max(spectra3h[:,1])
norm4h= spectra4h[:,1]/np.max(spectra4h[:,1])
norm6h= spectra6h[:,1]/np.max(spectra6h[:,1])
norm9h= spectra9h[:,1]/np.max(spectra9h[:,1])

plt.plot(spectra0h[:,0],norm0h[:], label = "Sin recocido")
plt.plot(spectra3h[:,0],norm3h[:], label = "3h recocido")
plt.plot(spectra4h[:,0],norm4h[:], label = "4h recocido" )
plt.plot(spectra6h[:,0],norm6h[:], label = "6h recocido")
plt.plot(spectra9h[:,0],norm9h[:], label = "9h recocido")

plt.xlabel("Longitud de onda (nm)")
plt.ylabel("Intensidad PL (normalizada por espectro)")
plt.title("Respuesta PL de WS2-WSe2 respecto al tiempo de recocido (Normalizado)")
plt.legend()
plt.show()
#find max 1.65 peak
max0h3Se = h*c/spectra0h[findmaxrange(spectra0h,700,800)][0,0][0]
max3h = h*c/spectra3h[findmaxrange(spectra3h,700,800)][0,0][0]
max4h = h*c/spectra4h[findmaxrange(spectra4h,760,800)][0,0][0]
max6h = h*c/spectra6h[findmaxrange(spectra6h,780,820)][0,0][0]
max9h = h*c/spectra6h[findmaxrange(spectra9h,780,820)][0,0][0]
max0h3S = h*c/spectra0h[findmaxrange(spectra0h,550,650)][0,0][0]

#integrate 1.65peak
area0h3Se = integraterange(spectra0h,700,800)
area3h = integraterange(spectra3h,650,800)
area4h = integraterange(spectra4h,700,820)
area6h = integraterange(spectra6h,750,830)
area9h = integraterange(spectra9h,750,830)

width0h = FWHM(spectra0h,700,800)
width3h = FWHM(spectra3h,650,800)
width4h = FWHM(spectra4h,700,850)
width6h = FWHM(spectra6h,700,880)
width9h = FWHM(spectra9h,700,880)

#find max 1.4 peak
maxi3h = h*c/spectra3h[findmaxrange(spectra3h,800,1000)][0,0][0]
maxi4h = h*c/spectra4h[findmaxrange(spectra4h,900,1000)][0,0][0]
maxi6h = h*c/spectra6h[findmaxrange(spectra6h,900,1000)][0,0][0]
maxi9h = h*c/spectra9h[findmaxrange(spectra9h,900,1000)][0,0][0]

#integrate 1.3 peak
areai3h = integraterange(spectra3h,850,1000)
areai4h = integraterange(spectra4h,850,970)
areai6h = integraterange(spectra6h,880,980)
areai9h = integraterange(spectra9h,880,980)

widthi3h = FWHM(spectra3h,850,950)
widthi4h = FWHM(spectra4h,850,1000)
widthi6h = FWHM(spectra6h,880,1000)
widthi9h = FWHM(spectra9h,880,1000)

#Proportion IX vs X0 peak
prop3h = areai3h/area3h
prop4h = areai4h/area4h
prop6h = areai6h/area6h
prop9h = areai9h/area9h

widthprop3h = widthi3h/width3h
widthprop4h = widthi4h/width4h
widthprop6h = widthi6h/width6h
widthprop9h = widthi9h/width9h


area3 = np.array([areai3h,areai4h,areai6h,areai9h])
widthi3 = np.array([width3h,width4h,width6h,width9h])
forlin3 = np.array ([[0,max0h3Se],[3,max3h],[4,max4h],[6,max6h],[9,max9h]])
forlini3 = np.array ([[3,maxi3h],[4,maxi4h],[6,maxi6h],[9,maxi9h]])
area3prop = np.array([[3,prop3h],[4,prop4h],[6,prop6h],[9,prop9h]])
width3prop = np.array([[3,widthprop3h],[4,widthprop4h],[6,widthprop6h],[9,widthprop9h]])

areatot0h3 = integraterange(spectra0h, 500, 1000)
areatot3h3 = integraterange(spectra3h, 500, 1000)
areatot4h3 = integraterange(spectra4h, 500, 1000)
areatot6h3 = integraterange(spectra6h, 500, 1000)
areatot9h3 = integraterange(spectra9h, 500, 1000)

areatot3 = np.array([areatot0h3,areatot3h3,areatot4h3,areatot6h3,areatot9h3])

plt.figure()
x = h*c/spectra9h[:,0]
plt.plot(x,norm4h[:], label = "4h anneal")
plt.xlim(1.2,2.2)
plt.xlabel("Energía (eV)")
plt.ylabel("Intensidad (u.a.)")
plt.title("Respuesta PL a 4h de annealing" )
plt.show()

"""MONOLAYEEEER"""
# load data
spectra0h = np.loadtxt('../profile/WS2-WSE2 0h_monolayer.txt')
spectra3h = np.loadtxt('../profile/WS2-WSE2 3h_monolayer.txt')
spectra4h = np.loadtxt('../profile/WS2-WSE2 4h_monolayer.txt')
spectra6h = np.loadtxt('../profile/WS2-WSE2 6h_monolayer.txt')
spectra9h = np.loadtxt('../profile/WS2-WSE2 9h_monolayer.txt')

spectra0h[:,0] = h*c/spectra0h[:,0] 
spectra3h[:,1] = spectra3h[:,1] - np.min(spectra3h[:,1])
spectra4h[:,1] = (spectra4h[:,1] - np.min(spectra4h[:,1]))
spectra6h[:,1] = (spectra6h[:,1] - np.min(spectra6h[:,1]))
spectra9h[:,1] = (spectra9h[:,1] - np.min(spectra9h[:,1]))

plt.figure()
plt.plot(spectra0h[:,0],spectra0h[:,1], label = "Sin recocido (60uW)")
plt.plot(spectra3h[:,0],spectra3h[:,1], label = "3h recocido (60uW)")
plt.plot(spectra4h[:,0],spectra4h[:,1], label = "4h recocido (450uW)" )
plt.plot(spectra6h[:,0],spectra6h[:,1], label = "6h recocido (400uW)")
plt.plot(spectra9h[:,0],spectra9h[:,1], label = "9h recocido (400uW)")

plt.xlabel("Longitud de onda (nm)")
plt.ylabel("Intensidad PL (cuentas)")
plt.title("Respuesta PL de la monocapa de WSe2 respecto al tiempo de recocido")
plt.legend()
plt.show()
#normal
norm0h = (spectra0h[:,1]-np.min(spectra0h[:,1])) /(np.max(spectra0h[:,1])-np.min(spectra0h[:,1]))
norm3h= spectra3h[:,1]/np.max(spectra3h[:,1])
norm4h= spectra4h[:,1]/np.max(spectra4h[:,1])
norm6h= spectra6h[:,1]/np.max(spectra6h[:,1])
norm9h= spectra9h[:,1]/np.max(spectra9h[:,1])

plt.plot(spectra0h[:,0],norm0h[:], label = "Sin recocido ")
plt.plot(spectra3h[:,0],norm3h[:], label = "3h recocido ")
plt.plot(spectra4h[:,0],norm4h[:], label = "4h recocido " )
plt.plot(spectra6h[:,0],norm6h[:], label = "6h recocido ")
plt.plot(spectra9h[:,0],norm9h[:], label = "9h recocido")
plt.xlabel("Longitud de onda (nm)")
plt.ylabel("Intensidad PL (normalizada por espectro)")
plt.title("Respuesta PL de la monocapa de WSe2 respecto al tiempo de recocido (Normalizado)")
plt.legend()
plt.show()
#find max 1.65 peak
max0hmo = h*c/spectra0h[findmaxrange(spectra0h,650,900)][0,0][0]
max3hmo = h*c/spectra3h[findmaxrange(spectra3h,700,900)][0,0][0]
max4hmo = h*c/spectra4h[findmaxrange(spectra4h,700,900)][0,0][0]
max6hmo = h*c/spectra6h[findmaxrange(spectra6h,780,900)][0,0][0]
max9hmo = h*c/spectra6h[findmaxrange(spectra9h,780,900)][0,0][0]

#integrate 1.65peak
area0hmo = -integraterange(spectra0h,700,800)
area3h = integraterange(spectra3h,680,830)
area4h = integraterange(spectra4h,720,840)
area6h = integraterange(spectra6h,750,850)
area9h = integraterange(spectra9h,750,850)

width0h = FWHM(spectra0h,700,900)
width3h = FWHM(spectra3h,700,900)
width4h = FWHM(spectra4h,700,900)
width6h = FWHM(spectra6h,700,900)
width9h = FWHM(spectra9h,700,900)

forlinmo = np.array ([[0,max0hmo],[3,max3hmo],[4,max4hmo],[6,max6hmo],[9,max9hmo]])
areamo = np.array([area3h,area4h,area6h,area9h])
widthmo = np.array([[3,width3h],[4,width4h],[6,width6h],[9,width9h]])

areatot0hmo = integraterange(spectra0h, 500, 1000)
areatot3hmo = integraterange(spectra3h, 500, 1000)
areatot4hmo = integraterange(spectra4h, 500, 1000)
areatot6hmo = integraterange(spectra6h, 500, 1000)
areatot9hmo = integraterange(spectra9h, 500, 1000)

areatotmo = np.array([areatot0hmo,areatot3hmo,areatot4hmo,areatot6hmo,areatot9hmo])


"""
CALCCCS
"""

ma1,ba1 = np.polyfit(area1prop[:,0],area1prop[:,1],1)
mw1,bw1 = np.polyfit(width1prop[:,0],width1prop[:,1],1)
ma2,ba2 = np.polyfit(area2prop[:,0],area2prop[:,1],1)
mw2,bw2 = np.polyfit(width2prop[:,0],width2prop[:,1],1)
ma3,ba3 = np.polyfit(area3prop[:,0],area3prop[:,1],1)
mw3,bw3 = np.polyfit(width3prop[:,0],width3prop[:,1],1)
moprop1 = area1/areamo
moprop2 = area2/areamo
moprop3 = area3/areamo

totprop1 = areatot1 / areatotmo
totprop2 = areatot2 / areatotmo
totprop3 = areatot3 / areatotmo
xprop = np.array([3,4,6,9])
#peaks shift
m1,b1 = np.polyfit(forlin1[:,0],forlin1[:,1],1)
mi1,bi1 = np.polyfit(forlini1[:,0],forlini1[:,1],1)

m2,b2 = np.polyfit(forlin2[:,0],forlin2[:,1],1)
mi2,bi2 = np.polyfit(forlini2[:,0],forlini2[:,1],1)

m3,b3 = np.polyfit(forlin3[:,0],forlin3[:,1],1)
mi3,bi3 = np.polyfit(forlini3[:,0],forlini3[:,1],1)
x = np.linspace (3,9,20)
plt.figure()
plt.plot(forlinmo[:,0],forlinmo[:,1],linestyle = 'dashdot', label = "Monocapa")
plt.plot(forlin1[:,0],forlin1[:,1],'-bo', label = "Punto 1")
#plt.plot(x,m1*x+b1,'--')
plt.plot(forlini1[:,0],forlini1[:,1],'-bo')
#plt.plot(x,mi1*x+bi1,'--')
plt.plot(forlin2[:,0],forlin2[:,1],'-ro', label = " Punto 2")
#plt.plot(x,m2*x+b2,'--')
plt.plot(forlini2[:,0],forlini2[:,1],'-ro')
#plt.plot(x,mi2*x+bi2,'--')

plt.plot(forlin3[:,0],forlin3[:,1],'-go', label = "Punto 3")
#plt.plot(x,m3*x+b3,'--')
plt.plot(forlini3[:,0],forlini3[:,1],'-go')
#plt.plot(x,mi3*x+bi3,'--')

plt.grid()
plt.xlabel ("Tiempo de recocido (h)")
plt.ylabel("Energía del pico (eV)")
plt.title("Shifteo de los picos de PL respecto al tiempo de recocido ")
plt.legend(loc="upper right")
plt.show()

plt.figure()
#plt.plot(area[:,0],area[:,1],'-o', label ="1.65 Peak (Normalized)")
#plt.plot(areai[:,0],areai[:,1],'-o', label ="1.4EeV peak (Normalized)")
plt.plot(area1prop[:,0],area1prop[:,1],'-bo',label ="Área del pico Punto 1")
plt.plot(width1prop[:,0],width1prop[:,1],'--bx' ,label ="FWHM Punto 1")
plt.plot(area2prop[:,0],area2prop[:,1],'-ro',label ="Área del pico Punto 2")
plt.plot(width2prop[:,0],width2prop[:,1],'--rx',label ="FWHM Punto 2")
plt.plot(area3prop[:,0],area3prop[:,1],'-go',label ="Área del pico Punto 3")
plt.plot(width3prop[:,0],width3prop[:,1],'--gx',label ="FWHM Punto 3")
plt.xlabel ("Tiempo de recocido (h)")
plt.title("Ratio del pico Intercara respecto al propio de WSe2 (IX/X0)")
plt.yscale('log')
plt.ylabel("Ratio (escala logarítmica)")
plt.grid()
plt.grid(which = 'minor', linestyle = '--')
plt.legend()
plt.show()

plt.figure()
#plt.plot(area[:,0],area[:,1],'-o', label ="1.65 Peak (Normalized)")
#plt.plot(areai[:,0],areai[:,1],'-o', label ="1.4EeV peak (Normalized)")

plt.plot(area1prop[:,0],moprop1,'-bo',label ="Punto 1")
#plt.plot(width1prop[:,0],width1prop[:,1],'-o',label ="FWHM Point 1")
plt.plot(area2prop[:,0],moprop2,'-ro',label ="Punto 2")
#plt.plot(width2prop[:,0],width2prop[:,1],'-o',label ="FWHM Point 2")
plt.plot(area3prop[:,0],moprop3,'-go',label ="Punto 3")
#plt.plot(width3prop[:,0],width3prop[:,1],'-o',label ="FWHM Point 3")
plt.xlabel ("Tiempo de recocido (h)")
plt.axhline(-area0h1Se/area0hmo,linestyle = "-.", color ='b')
plt.axhline(-area0h2Se/area0hmo, linestyle = "-.", color = 'r')
plt.axhline(-area0h3Se/area0hmo, linestyle = "-.", color = 'g')
print(-area0h3Se/area0hmo)
plt.title("Ratio del Area del Pico Monocapa-Intercara (IX/X0)")
#plt.yscale('log')
plt.ylabel("Ratio")
plt.ylim(0,0.5)
plt.grid()
plt.grid(which = 'minor', linestyle = '--')
plt.legend()
plt.show()

plt.figure()
plt.plot(xprop,totprop1[1:], '-bo', label ="Punto 1")
plt.plot(xprop,totprop2[1:], '-ro', label ="Punto 2")
plt.plot(xprop,totprop3[1:], '-go', label ="Punto 3")
plt.axhline(totprop1[0],linestyle = "-.", color ='b')
plt.axhline(totprop2[0], linestyle = "-.", color = 'r')
plt.axhline(totprop3[0], linestyle = "-.", color = 'g')
plt.xlabel ("Tiempo de recocido (h)")
plt.title("Ratio de las cuentas totales de cada punto respecto a la monocapa")
#plt.yscale('log')
plt.ylabel("Ratio")
plt.ylim(0,0.6)
plt.grid()
plt.grid(which = 'minor', linestyle = '--')
plt.legend(loc =1)
plt.show()
plt.show()